<template>
	<div class="WaterContaier">

		<div class="leftTop">
			<div class="title">
				<span>月供水量统计</span>
			</div>
			<div class="tmsg"  id="leftTop"  >

			</div>
		</div>

		<div class="rightTop">
			<div class="title">
				<span>月用水统计</span>
			</div>
			<div class="tmsg"  id="rightTop" >

			</div>
		</div>
		<div class="rightBottom">
			<div class="title">
				<span>日用水量统计</span>
			</div>
			<div class="tmsg"  id="rightBottom">

			</div>
		</div>
		
		<div class="leftBottom">
			<div class="title">
				<span>企业日用水排名</span>
			</div>
			<div class="tmsg"  id="leftBottom">
		
			</div>
		</div>
		

	</div>
</template>

<script>
	import {
		axios_get,
		axios_post
	} from "../../../until/request.js"
	
	
	export  default{
		data() {
			return {
				chart1:{},
				chart1option:{},
				myChart:{}
			}
		},
		methods:{
			drawChart1(xData,yData){		
				// let xData = ['2017', '2018', '2019', '2020', '2021'];
				// let yData = [150, 126, 260, 220, 184];
				this.chart1 = this.$echarts.init(document.getElementById("leftTop"));
				// 绘制左侧面
				const wid = 30;
				const w1 = Math.sin(Math.PI / 6) * wid; //4
				const w2 = Math.sin(Math.PI / 3) * wid; // 6.8
				const snapHeight = wid / 2;
				const CubeLeft = this.$echarts.graphic.extendShape({
				    shape: {
				        x: 0,
				        y: 0,
				    },
				    buildPath: function (ctx, shape) {
				        const xAxisPoint = shape.xAxisPoint;
				        const c0 = [shape.x, shape.y];
				        const c1 = [shape.x - w2, shape.y];
				        const c2 = [shape.x - w2, xAxisPoint[1]];
				        const c3 = [shape.x, xAxisPoint[1]];
				        ctx.moveTo(c0[0], c0[1]).lineTo(c1[0], c1[1]).lineTo(c2[0], c2[1]).lineTo(c3[0], c3[1]).closePath();
				    },
				});
				// 绘制右侧面
				const CubeRight = this.$echarts.graphic.extendShape({
				    shape: {
				        x: 0,
				        y: 0,
				    },
				    buildPath: function (ctx, shape) {
				        const xAxisPoint = shape.xAxisPoint;
				        const c1 = [shape.x, shape.y];
				        const c2 = [shape.x, xAxisPoint[1]];
				        const c3 = [shape.x + w1, xAxisPoint[1] - w2 + snapHeight];
				        const c4 = [shape.x + w1, shape.y - w2 + snapHeight];
				        ctx.moveTo(c1[0], c1[1]).lineTo(c2[0], c2[1]).lineTo(c3[0], c3[1]).lineTo(c4[0], c4[1]).closePath();
				    },
				});
				// 绘制顶面
				const CubeTop = this.$echarts.graphic.extendShape({
				    shape: {
				        x: 0,
				        y: 0,
				    },
				    buildPath: function (ctx, shape) {
				        //
				        const c1 = [shape.x, shape.y];
				        const c2 = [shape.x + w1, shape.y - w2 + snapHeight]; //右点
				        const c3 = [shape.x - w2 + w1, shape.y - w2 + snapHeight];
				        const c4 = [shape.x - w2, shape.y];
				        ctx.moveTo(c1[0], c1[1]).lineTo(c2[0], c2[1]).lineTo(c3[0], c3[1]).lineTo(c4[0], c4[1]).closePath();
				    },
				});
				// 三个面图形
				this.$echarts.graphic.registerShape('CubeLeft', CubeLeft);
				this.$echarts.graphic.registerShape('CubeRight', CubeRight);
				this.$echarts.graphic.registerShape('CubeTop', CubeTop);
				
				
				this.chart1option = {
				    tooltip: {
				        trigger: 'axis',
				        axisPointer: {
				            type: 'shadow',
				        },
				        backgroundColor: 'rgba(9, 24, 48, 0.5)',
				        borderColor: 'rgba(75, 253, 238, 0.4)',
				        textStyle: {
							fontsize:25,
				            color: '#CFE3FC',
				        },
				        borderWidth: 1,
				        formatter: function (params) {
				            let item = '';
				            item += params[0].name;
				            $(params).each(function (idx, itm) {
				                item += ': ' + itm.value+'吨';
				            });
				            return item;
				        },
				    },
				    grid: {
				        top: '10%',
				        left: '5%',
				        bottom: '5%',
				        right: '5%',
				        containLabel: true,
				    },
				    xAxis: {
				        type: 'category',
				        data: xData,
				        axisLine: {
				            show: true,
				            lineStyle: {
				                color: '#3e6f8e',
				                width: 1,
				            },
				        },
				        axisTick: {
				            show: false,
				            length: 9,
				            alignWithLabel: false,
				            lineStyle: {
				                color: '#AAA',
				            },
				        },
				        axisLabel: {
				            fontSize: 24,
				            margin: 10,
				            color: 'white',
				        },
				        splitLine: {
				            show: false,
				            lineStyle: {
				                color: '#ffffff',
				                opacity: 0.2,
				                width: 1,
				            },
				        },
				    },
				    yAxis: {
				        name: '单位：吨',
				        type: 'value',
				        nameTextStyle: {
				            color: 'white',
				            fontSize: 20,
				        },
				        axisLine: {
				            show: true,
				            lineStyle: {
				                color: '#3e6f8e',
				                width: 1,
				            },
				        },
				        axiosTick: {
				            show: false,
				        },
				        axisLabel: {
				            color: 'white',
				            fontSize: 24,
				            margin: 10,
				        },
				        splitLine: {
				            show: true,
				            lineStyle: {
				                color: '#ffffff',
				                opacity: 0.2,
				                width: 1,
				            },
				        },
				        nameGap: 20,
				    },
				    series: [
				        {
				            type: 'bar',
				            label: {
				                normal: {
				                    show: true,
				                    position: 'top',
				                    fontSize: 16,
				                    color: '#fff',
				                    offset: [0, -10],
				                },
				            },
				            tooltip: {
				                show: false,
				            },
				            itemStyle: {
				                color: 'transparent',
				            },
				            data: yData,
				        },
				        {
				            type: 'custom',
				            renderItem: (params, api) => {
				                const location = api.coord([api.value(0), api.value(1)]);
				                location[0] = location[0] + wid * 0;
				                const xlocation = api.coord([api.value(0), 0]);
				                xlocation[0] = xlocation[0] + wid * 0;
				                return {
				                    type: 'group',
				                    children: [
				                        {
				                            type: 'CubeLeft',
				                            shape: {
				                                api,
				                                xValue: api.value(0),
				                                yValue: api.value(1),
				                                x: location[0],
				                                y: location[1],
				                                xAxisPoint: xlocation,
				                            },
				                            style: {
				                                fill: new this.$echarts.graphic.LinearGradient(0, 0, 0, 1, [
				                                    {
				                                        offset: 0,
				                                        color: '#059de6',
				                                    },
				                                    {
				                                        offset: 1,
				                                        color: '#059de6',
				                                    },
				                                ]),
				                            },
				                        },
				                        {
				                            type: 'CubeRight',
				                            shape: {
				                                api,
				                                xValue: api.value(0),
				                                yValue: api.value(1),
				                                x: location[0],
				                                y: location[1],
				                                xAxisPoint: xlocation,
				                            },
				                            style: {
				                                fill: new this.$echarts.graphic.LinearGradient(0, 0, 0, 1, [
				                                    {
				                                        offset: 0,
				                                        color: '#254193',
				                                    },
				                                    {
				                                        offset: 1,
				                                        color: '#254193',
				                                    },
				                                ]),
				                            },
				                        },
				                        {
				                            type: 'CubeTop',
				                            shape: {
				                                api,
				                                xValue: api.value(0),
				                                yValue: api.value(1),
				                                x: location[0],
				                                y: location[1],
				                                xAxisPoint: xlocation,
				                            },
				                            style: {
				                                fill: new this.$echarts.graphic.LinearGradient(0, 0, 0, 1, [
				                                    {
				                                        offset: 0,
				                                        color: '#17e0fe',
				                                    },
				                                    {
				                                        offset: 1,
				                                        color: '#17e0fe',
				                                    },
				                                ]),
				                            },
				                        },
				                    ],
				                };
				            },
				            color: 'blue',
				            data: yData,
				        },
				    ],
				};

				
				this.chart1.setOption(this.chart1option);
			},			
			drawChart2(datax,datay){
				this.chart1 = this.$echarts.init(document.getElementById("rightTop"));

				this.chart1option = {
				   
				    xAxis: {
				        type: 'category',
				        data:datax ,
				        axisTick: false,
				        boundaryGap: false,
				 
				        axisLabel: {
				            textStyle: {
				                color: 'blank',
				                fontSize: 24
				            },
				            margin: 16
				        },
				        axisLine: {
				            lineStyle: {
				                width: 3,
				                color: 'rgba(108, 144, 175, .5)'
				            }
				        }
				    },
				    grid: {
				        left: '18%',
				        top: '7%',
				        right: '4%'
				    },
				    tooltip: {
				        trigger: 'axis',
				
				        // showContent: false
				    },
				    yAxis: {
				        type: 'value',
				        axisTick: false,
				        splitLine: false,
				        axisLine: {
				            lineStyle: {
				                width: 3,
				                color: 'rgba(108, 144, 175, .5)'
				            }
				        },
				        axisLabel: {
				            textStyle: {
				                color: 'rgba(255,255,255,.8)',
				                fontSize: 24
				            },
				            margin: 24
				        }
				    },
				    series: [{
				        data:datay,
				        type: 'line',
				        symbol: 'circle',
				        symbolSize: 13,
				        showSymbol: false,
				        smooth:true,
				        itemStyle: {
				            color: 'rgba(56, 248, 255, 1)',
				            borderColor: 'rgba(56, 248, 255, 0.2)',
				            borderWidth: 18
				        },
				        lineStyle: {
				            color: {
				                type: 'linear',
				                x: 0,
				                y: 0,
				                x2: 0,
				                y2: 1,
				                colorStops: [{
				                    offset: 0,
				                    color: 'rgba(56, 248, 255, 1)' // 0% 处的颜色
				                }, {
				                    offset: 1,
				                    color: 'rgba(56, 248, 255, 1)' // 100% 处的颜色
				                }],
				                global: false // 缺省为 false
				            },
				            width: 3
				        },
				        areaStyle: {
				            color: {
				                type: 'linear',
				                x: 0,
				                y: 0,
				                x2: 0,
				                y2: 1,
				                colorStops: [{
				                    offset: 0,
				                    color: 'rgba(56, 248, 255, .4)' // 0% 处的颜色
				                }, {
				                    offset: 1,
				                    color: 'rgba(56, 248, 255, 0)' // 100% 处的颜色
				                }],
				                global: false // 缺省为 false
				            }
				        }
				    }]
				};
				this.chart1.setOption(this.chart1option);
			},
			drawChart3(chartData){
				this.myChart = this.$echarts.init(document.getElementById("leftBottom"), null, {
					renderer: "svg",
				});
				
				// var chartData = [
				//         {name:'2020.1', value: 16758},
				//         {name:'2020.2', value: 15001},
				//         {name:'2020.3', value: 28932},
				//         {name:'2020.4', value: 36245},
				//         {name:'2020.5', value: 31563},
				//         {name:'2020.6', value: 36389},
				//         {name:'2020.7', value: 38000}
				//     ];
				
				    let  option= {
				       
				        tooltip: {
				            show: true,
				            trigger: 'axis',  //axis , item
				            backgroundColor:'rgba(0,15,78,0.6)',
				            borderColor:'#00afff',
				            borderWidth: 1,
				            borderRadius: 0,
				            textStyle: {
				                color: "#fff",
				                fontSize: 13,
				                align:'left'
				            },
				            axisPointer:{
				                type: 'line', //'line' | 'cross' | 'shadow' | 'none
				                lineStyle: {
				                    width: 1,
				                    type: 'dotted',
				                    color: 'rgba(46,149,230,.9)'
				                }
				            }
				        },
				       
				        grid: {
				            top: '15%',
				            right: '3%',
				            bottom: '20%',
				            left: '15%'
				        },
				        xAxis:{
				            type: 'category',
				            axisLabel: {
				                show: true,
				                interval: 0, 
								 rotate: 45,
				                textStyle: {
				                    color: '#fff',
				                    fontSize: 24
				                },
				                formatter: '{value}',
				            },
				            axisLine:{
				                lineStyle:{
				                    color:'rgba(15,45,134,.9)'
				                }
				            },
				            axisTick:{
				                show: false //坐标轴小标记
				            },
				            data: (function(data){
				                var arr=[];
				                data.forEach(function(items){
				                    arr.push(items.name);   //name
				                });
				                return arr;
				            })(chartData)  //载入横坐标数据
				        },
				        yAxis: {
				            type: 'value',
				            name: '',
				            nameTextStyle:{
				                color:'#93d3fc',
				                fontSize: 24,
				                align: 'right'
				            },
				            axisLabel: {
				                show: true,
				                textStyle: {
				                    color: '#9bc8ff',
				                    fontSize: 24
				                },
				                interval: 0, //类目间隔 设置为 1，表示『隔一个标签显示一个标签』
				                margin: 10,
				                //formatter: '{value}'
				            },
				            splitNumber: 5, //y轴刻度设置(值越大刻度越小)
				            axisLine:{ //y轴线
				                show: false
				            },
				            splitLine: {
				                show: true,
				                lineStyle: {
				                    color: 'rgba(15,45,134,.6)', //横向网格线颜色
				                    width: 1
				                }
				            },
				            axisTick:{
				                show: false //坐标轴小标记
				            }
				        },
				        series:[
				            {
				                name:'',
				                type: 'effectScatter', //effectScatter 涟漪效果, scatter 散点
				                stack: '',
				                label: {
				                    normal: {
				                        show: false,
				                        position: 'top',
				                        textStyle: {
				                            color: '#9bc8ff',
				                            fontSize: 12
				                        },
				                        formatter: '{c}' //图形上显示数字
				                    }
				                },
				                itemStyle: {
				                    normal: {
				                        color: 'rgba(255,55,135,1)', //颜色
				                    }
				                },
				                symbol: 'circle', //circle, rect, roundRect, triangle,  pin, diamond, arrow
				                symbolPosition: 'end',
				                symbolSize: 30,
				                symbolOffset: [0, '-120%'],
				                data: (function(data){
				                    var arr=[];
				                    data.forEach(function(items){ 
				                        var itemName = items.name,
				                            itemValue = items.value,
				                            itemStyle = itemValue/10; //console.log(itemStyle)
				                        arr.push({
				                            name: itemName,
				                            value: itemValue,
				                            symbolSize: itemStyle
				                        })
				                    });
				                    return arr;
				                })(chartData)  //载入数据并设置图形尺寸
				            }
				        ]   
				    };
				
				    var app = {
				            curIndex: -1,
				    };
					let  _that=this;
				    setInterval(()=> {
				        var dataLen = chartData.length;
				        
				        // 取消之前高亮的图形
				        _that.myChart.dispatchAction({
				            type: 'downplay',
				            seriesIndex: 0,
				            dataIndex: app.curIndex
				        });			    
				        app.curIndex = (app.curIndex + 1) % dataLen;				    
				        // 高亮当前图形
				        _that.myChart.dispatchAction({
				            type: 'highlight',
				            seriesIndex: 0,
				            dataIndex: app.curIndex,
				        });				    
				        // 显示 tooltip
				        _that.myChart.dispatchAction({
				            type: 'showTip',
				            seriesIndex: 0,
				            dataIndex: app.curIndex
				        });
				    }, 3000);

				
				
				
				
				
				this.myChart.setOption(option);
				//随窗口大小变化重置echarts大小
				window.onresize = this.myChart.resize;
			},		
			drawChart4(datax,datay){
				var fontColor = '#30eee9';
				this.chart1 = this.$echarts.init(document.getElementById("rightBottom"));
				//let datax=['1月','2月','3月','4月','5月','6月','7月','8月','9月','10月','11月','12月']；
			//let  datay=	[150, 232, 201, 154, 190, 330, 410,150, 232, 201, 154, 190]；
				
				
				this.chart1option ={
				  //       backgroundColor:'#11183c',
						grid: {
					        left: '15%',
				          //   right: '10%',
				          //   top:'20%',
					        // bottom: '15%',
					        // containLabel: true
						},
						tooltip : {
							show: true,
							trigger: 'item'
						},
						legend: {
							show:true,
							x:'center',
							y:'35',
							icon: 'stack',
							itemWidth:10,
							itemHeight:10,
							textStyle:{
								color:'#1bb4f6'
							},
							data:['用水量']
						},
						xAxis : [
					        {
					            type : 'category',
					            boundaryGap : false,
					            axisLabel:{
					            	color: fontColor,
                        fontSize: 24
					            },
					            axisLine:{
				               		show:true,
				               		lineStyle:{
						            	color:'#397cbc'
						            }
								},
								axisTick:{
					            	show:false,
					            },  
					            splitLine:{
					            	show:false,
						            lineStyle:{
						            	color:'#195384'
						            }
						        },
					            data :datax 
					        }
					    ],
					    yAxis : [
							{
								type : 'value',
				
								axisLabel : {
									formatter: '{value}',
									textStyle:{
										color:'#2ad1d2',
                    fontSize: 24
									}
								},
								axisLine:{
									lineStyle:{
										color:'#27b4c2'
									}
								},
				
								splitLine:{
									show:false,
									lineStyle:{
										color:'#11366e'
									}
								}
							},
							
						],
						series : [
							
							{
								name:'浏览量',
								type:'line',
								stack: '总量',
								symbol:'circle',
								symbolSize: 8,
					            itemStyle: {
							        normal: {
							            color: '#aecb56',
							            lineStyle: {
											color: "#aecb56",
											width:1
							            },
							            areaStyle: { 
											//color: '#94C9EC'
											color: new this.$echarts.graphic.LinearGradient(0, 1, 0, 0, [{
												offset: 0,
												color: 'rgba(7,44,90,0.3)'
											}, {
												offset: 1,
												color: 'rgba(114,144,89,0.9)'
											}]),
							            }
							        }
								},
								data:datay
							}
						]
					};
				
				this.chart1.setOption(this.chart1option);
			},
			
			
			ajaxDrawChart1(){				
				let xData =[]; //['2017', '2018', '2019', '2020', '2021'];
				let yData =[];// [150, 126, 260, 220, 184];

				axios_post("/water/monthSupplyWaterCount").then(response=>{
		
					for(let  i=0;i<response.data.length;i++){
						xData.push(this.parseTime(response.data[i].createTime,'{m}'));
						yData.push(response.data[i].waterNumber);						
					}				
					this.drawChart1(xData,yData);
				})			
			},
			ajaxDrawChart2(){
				let datax = [];
				let datay = [];
				axios_post("/water/monthUseWaterCount").then(response=>{
					
					for(let  i=0;i<response.data.length;i++){
						datax.push(this.parseTime(response.data[i].createTime,'{y}-{m}'));
						datay.push(parseFloat(response.data[i].waterNumber).toFixed(2));	
					}
					this.drawChart2(datax,datay)
				})	
			},			
			ajaxDrawChart3(){
				axios_post("/water/corpDayUseWaterRanking").then(response=>{
					console.log(response);
					let  chartData=[];
					for(let  i=0;i<response.data.length;i++){
						let  obj={
							name:response.data[i].corpName,
							value:parseFloat(response.data[i].waterNumber).toFixed(2)
						}
						chartData.push(obj);
					}
					
				//console.log(chartData);
					this.drawChart3(chartData);
				})
				
			},
			//企业日用水排名
			ajaxDrawChart4(){
				let datax =[];
				let  datay= [];				
				axios_post("/water/dayUseWaterCount").then(response=>{
			
					for(let  i=0;i<response.data.length;i++){
						datax.push(this.parseTime(response.data[i].createTime,'{m}-{d}'));
						datay.push(parseFloat(response.data[i].waterNumber).toFixed(2));						
					}				
					this.drawChart4(datax,datay);
				})			
			},
			
		},
		
		mounted() {
			this.ajaxDrawChart1();
			this.ajaxDrawChart2();
			this.ajaxDrawChart3();
			this.ajaxDrawChart4();
			
		}
		
		
		
		
		
		
		
		
		
		
	} 
	
	
	
</script>

<style scoped="scoped" lang="less">
	.WaterContaier {
		height: 100%;
		width: 100%;
		display: flex;
		flex-direction: row;
		flex-wrap: wrap;
		align-items: center;
		justify-content: space-around;
		div{
			width: 49%;
			height: 49%;
			.title {
				width: 100%;
				height: 38px;
				background-image: url(../../../assets/image/Left/titleD.png);
				background-size: 100% 100%;
				font-family: MytitileName;
				font-size: 24px;
				display: flex;
				align-items: center;
				color: #98deff;
				letter-spacing: 3px;
			
				span {
					width: 70%;
					text-indent: 70px;
				}
			
				button {
					cursor: pointer;
					background-color: #020919;
					height: 80%;
					width: 20%;
					font-size: 24px;
					color: #FFFFFF;
					text-align: center;
					border-radius: 5px;
				}
			}
			.tmsg{
				height: calc(100% - 38px);
				width: 100%;
				
			}
			
			
			
			
		}
		
	}
	
	
	
	
	
</style>
